!= Module DynamicsHEVI
!
! Authors::   SUGIYAMA Ko-ichiro, ODAKA Masatsugu 
! Version::   $Id: dynamicshevi.f90,v 1.2 2011-06-03 07:45:39 sugiyama Exp $ 
! Tag Name::  $Name:  $
! Copyright:: Copyright (C) GFD Dennou Club, 2007. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview 
!
!ǥϳز׻뤿ɬפȤʤؿ«ͤ⥸塼
!Ūˤϰʲι׻뤿δؿǼ.  
!  * ή
!  * Ϲ
!  * Ϲ
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!  * ʡؿζΥˤ, 2 ٤Υۤ
!    ѤƤ뤿, Ϲη׻ץˤ
!    differentiate_center4 ⥸塼ꤹ뤳ȤϤǤʤΤ.
!
!== Future Plans
!

module DynamicsHEVI
  !
  !۲ˡѤϳزγƹη׻⥸塼. 
  !Ūˤϰʲι׻뤿δؿǼ.  
  !  * ή
  !  * Ϲ
  !  * Ϲ
  !

  !⥸塼ɤ߹
  use dc_types,   only : DP, STRING
  use dc_iounit,  only : FileOpen
  use dc_message, only : MessageNotify
  use gtool_historyauto, only: HistoryAutoAddVariable, HistoryAutoPut 

  use mpi_wrapper,only: myrank
  use gridset, only: &
    &                 imin,            &! x β
    &                 imax,            &! x ξ
    &                 jmin,            &! y β
    &                 jmax,            &! y ξ
    &                 kmin,            &! z β
    &                 kmax,            &! z ξ
    &                 nx,              &! x ʪΰξ
    &                 ny,              &! x ʪΰξ
    &                 nz,              &! y ʪΰξ
    &                 ncmax                ! ʪ
  use constants,only: CpDry,           &! ʬǮ
    &                 MolWtDry,        &! ʬʬ
    &                 Grav              ! ϲ®
  use composition, only: SpcWetSymbol,    &!
    &                 GasNum,          &! 
    &                 IdxG,            &!
    &                 MolWtWet          ! ʬʬ
  use timeset, only:  DelTimeShort, DelTimeLong
  use axesset, only:  x_dx, y_dy, z_dz, r_dz,                &! ʻҴֳ
    &                 xyz_avr_pyz, xyr_avr_pyr, xqz_avr_pqz, &
    &                 pyz_avr_xyz, pyr_avr_xyr, pqz_avr_xqz, &
    &                 xyz_avr_xqz, pyz_avr_pqz, xyr_avr_xqr, &
    &                 xqz_avr_xyz, pqz_avr_pyz, xqr_avr_xyr, &
    &                 xyz_avr_xyr, pyz_avr_pyr, xqz_avr_xqr, &
    &                 xyr_avr_xyz, pyr_avr_pyz, xqr_avr_xqz 
  use basicset, only: xyz_VelSoundBZ, &!ܾβ® 
    &                 xyz_DensBZ,     &!ܾ̩
    &                 xyz_PTempBZ,    &!ܾβ
    &                 xyz_VPTempBZ,    &!ܾβ
    &                 xyzf_QMixBZ,    &
    &                 xyr_QMixBZPerMolWt,  &
    &                 xyr_QMixBZ   
  use xyz_deriv_module
  use xyz_deriv_c4_module, only: pyz_c4dx_xyz, xqz_c4dy_xyz, xyr_c4dz_xyz, &
    &                            xyz_c4dx_pyz, pqz_c4dy_pyz, pyr_c4dz_pyz, &
    &                            pqz_c4dx_xqz, xyz_c4dy_xqz, xqr_c4dz_xqz, &
    &                            pyr_c4dx_xyr, xqr_c4dy_xyr, xyz_c4dz_xyr
  use setmargin,only: SetMargin_xyzf, SetMargin_xyz, &
    &                 SetMargin_pyz, SetMargin_xqz, SetMargin_xyr
  use fillnegative, only: FillNegativeQMix


  !ۤηػ
  implicit none

  !°λ
  private
  
  real(DP), save         :: beta  = 5.0d-1   !󥯥˥륽ˡʤ 0.5
                                             !ˡʤ 1
  real(DP), allocatable, save :: xyz_F1BZ(:,:,:)  !η׻Ѥ
  real(DP), allocatable, save :: xyr_F2BZ(:,:,:)  !η׻Ѥ

  integer, save         :: N = 10            !/μ, ˡ
  integer, save         :: M = 10            !ȿ
  integer, save         :: NUD = 1           !ξ廰ʬ
  integer, save         :: NLD = 1           !βʬ
  integer, save         :: NAL = 1           !LU ʬη L ˡ
  integer, save         :: NA = 3            !NUD + NLD + 1

  real(DP), allocatable, save :: A(:)              !гʬ
  real(DP), allocatable, save :: B(:)              !ξ廰ʬ
  real(DP), allocatable, save :: C(:)              !βʬ
!  real(DP), allocatable, save :: AU2(:,:)          !LU ʬη U (2 )
  real(DP), allocatable, save :: AL1(:)            !LU ʬη L (1 )
!  real(DP), allocatable, save :: AL2(:,:)          !LU ʬη L (2 )
  integer, allocatable, save  :: IP(:)             !ʬԥܥåȸ򴹤ξǼ

  integer, save  :: RegXMin = 1
  integer, save  :: RegXMax = 1
  integer, save  :: RegYMin = 1
  integer, save  :: RegYMax = 1
  integer, save  :: RegZMin = 1
  integer, save  :: RegZMax = 1

  real(DP), save :: Nu  = 0.0d0           !ȸθ그
  real(DP), save :: NuHh   = 0.0d0        !Ǵη (ʿ)
  real(DP), save :: NuVh   = 0.0d0        !Ǵη (ľ)
  real(DP), save :: NuHm  = 0.0d0         !Ǵη (ʿ)
  real(DP), save :: NuVm  = 0.0d0         !Ǵη (ľ)

  !public 
  public Dynamics_Init
  public Dynamics_Long_forcing
  public Dynamics_Short_forcing


contains

  subroutine Dynamics_Init(cfgfile)

    !ۤηػ
    implicit none
    
    character(STRING), intent(in) :: cfgfile         !NAMELIST ե
    real(DP)  :: DelXMin, DelYMin, DelZMin
    real(DP)  :: AlphaSound = 1.0e-7  !ȸη
    real(DP)  :: AlphaNDiff = 1.0d-4
    real(DP)  :: NDiffRatio = 1.0d0  !®٤ФǴ夲Ͽ 1 ʾˤ. 
    integer   :: unit            !ֹ
    integer   :: l

    NAMELIST /Dynamics_nml/ AlphaSound, AlphaNDiff, NDiffRatio

    !ե륪ץ. . 
    call FileOpen(unit, file=cfgfile, mode='r')
    read(unit, NML=dynamics_nml)
    close(unit)
    
    !-------------------------------------------------------------------
    ! ȸθΨ   Min(DelX, DelZ) ** 2.0 
    !
    DelXMin = minval(x_dx)
    DelYMin = minval(y_dy)
    DelZMin = minval(z_dz)
    Nu = AlphaSound * ( Min(DelXMin, DelZMin) ** 2.0d0 ) / DelTimeShort
    
    ! CReSS ޥ˥奢Ǥ, 2 濴ʬξ, Alpha < 1/8 餤ŬȽҤ٤Ƥ. 
    ! deepconv Ǥ NuH Ȥ 500 ʾͤäƤ,
    NuHh = AlphaNDiff * ( SQRT(DelXMin*DelYMin) ** 2.0d0 ) / DelTimeLong
    NuVh = AlphaNDiff * ( DelZMin ** 2.0d0 ) / DelTimeLong
    NuHm = NuHh * NDiffRatio
    NuVm = NuVh * NDiffRatio

    if (myrank == 0) then 
      call MessageNotify( "M", "DynamicsHEVI_init", "Nu = %f", d=(/Nu/) )
      call MessageNotify( "M", "DynamicsHEVI_init", "NuHh = %f", d=(/NuHh/) )
      call MessageNotify( "M", "DynamicsHEVI_init", "NuVh = %f", d=(/NuVh/) )
      call MessageNotify( "M", "DynamicsHEVI_init", "NuHm = %f", d=(/NuHm/) )
      call MessageNotify( "M", "DynamicsHEVI_init", "NuVm = %f", d=(/NuVm/) )
    end if

    ! ˡη׻ν
    !
    call DynamicsVI_init()


    call HistoryAutoAddVariable(  &
      & varname='PTempAdv', &
      & dims=(/'x','y','z','t'/),     &
      & longname='Advection term of potential temperature',  &
      & units='K.s-1',    &
      & xtype='double')
    
    call HistoryAutoAddVariable(  &
      & varname='PTempNDiff',&
      & dims=(/'x','y','z','t'/),     &
      & longname='Numerical diffusion term of potential temperature',&
      & units='K.s-1',    &
      & xtype='double')

    call HistoryAutoAddVariable(  &
      & varname='CDensAdv', &
      & dims=(/'x','y','z','t'/),     &
      & longname='Advection term of cloud density',  &
      & units='K.m-3.s-1',    &
      & xtype='double')
    
    call HistoryAutoAddVariable(  &
      & varname='CDensNDiff',&
      & dims=(/'x','y','z','t'/),     &
      & longname='Numerical diffusion term of cloud density',&
      & units='K.m-3.s-1',    &
      & xtype='double')

    do l = 1, ncmax
      call HistoryAutoAddVariable(  &
        & varname=trim(SpcWetSymbol(l))//'_Adv', &
        & dims=(/'x','y','z','t'/),     &
        & longname='Advection term of '          &
        &           //trim(SpcWetSymbol(l))//' mixing ratio',  &
        & units='kg.kg-1.s-1',    &
        & xtype='double')
      
      call HistoryAutoAddVariable(  &
        & varname=trim(SpcWetSymbol(l))//'_NDiff', & 
        & dims=(/'x','y','z','t'/),     &
        & longname='Diffusion term of '          &
        &           //trim(SpcWetSymbol(l))//' mixing ratio',  &
        & units='kg.kg-1.s-1',    &
        & xtype='double')
    end do

    call HistoryAutoAddVariable(  &
      & varname='VelXAdv', &
      & dims=(/'x','y','z','t'/),     &
      & longname='Advection term of velocity (x)',  &
      & units='K.m-3.s-1',    &
      & xtype='double')
    
    call HistoryAutoAddVariable(  &
      & varname='VelXNDiff',&
      & dims=(/'x','y','z','t'/),     &
      & longname='Numerical diffusion term of velocity (x)',&
      & units='K.m-3.s-1',    &
      & xtype='double')

    call HistoryAutoAddVariable(  &
      & varname='VelXPGrad', &
      & dims=(/'x','y','z','t'/),     &
      & longname='Pressure gradient term of velocity (x)',  &
      & units='K.m-3.s-1',    &
      & xtype='double')

    call HistoryAutoAddVariable(  &
      & varname='VelYAdv', &
      & dims=(/'x','y','z','t'/),     &
      & longname='Advection term of velocity (y)',  &
      & units='K.m-3.s-1',    &
      & xtype='double')
    
    call HistoryAutoAddVariable(  &
      & varname='VelYNDiff',&
      & dims=(/'x','y','z','t'/),     &
      & longname='Numerical diffusion term of velocity (y)',&
      & units='K.m-3.s-1',    &
      & xtype='double')

    call HistoryAutoAddVariable(  &
      & varname='VelYPGrad', &
      & dims=(/'x','y','z','t'/),     &
      & longname='Pressure gradient term of velocity (y)',  &
      & units='K.m-3.s-1',    &
      & xtype='double')

    call HistoryAutoAddVariable(  &
      & varname='VelZAdv', &
      & dims=(/'x','y','z','t'/),     &
      & longname='Advection term of velocity (z)',  &
      & units='K.m-3.s-1',    &
      & xtype='double')
    
    call HistoryAutoAddVariable(  &
      & varname='VelZNDiff',&
      & dims=(/'x','y','z','t'/),     &
      & longname='Numerical diffusion term of Velocity (z)',&
      & units='K.m-3.s-1',    &
      & xtype='double')

    call HistoryAutoAddVariable(  &
      & varname='VelZBuoyT',&
      & dims=(/'x','y','z','t'/),     &
      & longname='Buoyancy (Temperature)',&
      & units='K.m-3.s-1',    &
      & xtype='double')

    call HistoryAutoAddVariable(  &
      & varname='VelZBuoyM',&
      & dims=(/'x','y','z','t'/),     &
      & longname='Buoyancy (MolWt)',&
      & units='K.m-3.s-1',    &
      & xtype='double')

    call HistoryAutoAddVariable(  &
      & varname='VelZBuoyD',&
      & dims=(/'x','y','z','t'/),     &
      & longname='Buoyancy (Drag)',&
      & units='K.m-3.s-1',    &
      & xtype='double')

    call HistoryAutoAddVariable(  &
      & varname='VelZPGrad', &
      & dims=(/'x','y','z','t'/),     &
      & longname='Pressure gradient term of velocity (z)',  &
      & units='K.m-3.s-1',    &
      & xtype='double')

  end subroutine Dynamics_Init


  subroutine Dynamics_Long_forcing(        &
    & Time, DelTime,              & ! (in)
    & pyz_VelXBl,  pyz_VelXNl,    & ! (in)
    & xqz_VelYBl,  xqz_VelYNl,    & ! (in)
    & xyr_VelZBl,  xyr_VelZNl,    & ! (in)
    & xyz_PTempBl, xyz_PTempNl,   & ! (in)
    & xyzf_QMixBl, xyzf_QMixNl,   & ! (in)
    & xyz_KmBl,    xyz_KmNl,      & ! (in)
    & xyz_CDensBl, xyz_CDensNl,   & ! (in)
    & pyz_DVelXDtNl,              & ! (inout)
    & xqz_DVelYDtNl,              & ! (inout)
    & xyr_DVelZDtNl,              & ! (inout)
    & xyz_DPTempDtNl,             & ! (inout)
    & xyzf_DQMixDtNl,             & ! (inout)
    & xyz_DKmDtNl,                & ! (inout)
    & xyz_DCDensDtNl,             & ! (inout)
    & xyz_PTempAl,                & ! (out)
    & xyzf_QMixAl                 & ! (out)
    & )

    implicit none

    real(DP), intent(in) :: Time, DelTime
    real(DP), intent(in) :: pyz_VelXBl(imin:imax,jmin:jmax,kmin:kmax)
    real(DP), intent(in) :: pyz_VelXNl(imin:imax,jmin:jmax,kmin:kmax)
    real(DP), intent(in) :: xqz_VelYBl(imin:imax,jmin:jmax,kmin:kmax)
    real(DP), intent(in) :: xqz_VelYNl(imin:imax,jmin:jmax,kmin:kmax)
    real(DP), intent(in) :: xyr_VelZBl(imin:imax,jmin:jmax,kmin:kmax)
    real(DP), intent(in) :: xyr_VelZNl(imin:imax,jmin:jmax,kmin:kmax) 
    real(DP), intent(in) :: xyz_PTempBl(imin:imax,jmin:jmax,kmin:kmax)
    real(DP), intent(in) :: xyz_PTempNl(imin:imax,jmin:jmax,kmin:kmax)
    real(DP), intent(in) :: xyzf_QMixBl(imin:imax,jmin:jmax,kmin:kmax, 1:ncmax)
    real(DP), intent(in) :: xyzf_QMixNl(imin:imax,jmin:jmax,kmin:kmax, 1:ncmax)
    real(DP), intent(in) :: xyz_KmBl(imin:imax,jmin:jmax,kmin:kmax)
    real(DP), intent(in) :: xyz_KmNl(imin:imax,jmin:jmax,kmin:kmax)
    real(DP), intent(inout) :: pyz_DVelXDtNl(imin:imax,jmin:jmax,kmin:kmax)
    real(DP), intent(inout) :: xqz_DVelYDtNl(imin:imax,jmin:jmax,kmin:kmax) 
    real(DP), intent(inout) :: xyr_DVelZDtNl(imin:imax,jmin:jmax,kmin:kmax) 
    real(DP), intent(inout) :: xyz_DPTempDtNl(imin:imax,jmin:jmax,kmin:kmax)
    real(DP), intent(inout) :: xyzf_DQMixDtNl(imin:imax,jmin:jmax,kmin:kmax, 1:ncmax)
    real(DP), intent(inout) :: xyz_DKmDtNl(imin:imax,jmin:jmax,kmin:kmax)
    real(DP), intent(out) :: xyz_PTempAl(imin:imax,jmin:jmax,kmin:kmax) 
    real(DP), intent(out) :: xyzf_QMixAl(imin:imax,jmin:jmax,kmin:kmax, 1:ncmax)
    real(DP), intent(in) :: xyz_CDensBl(imin:imax,jmin:jmax,kmin:kmax)
    real(DP), intent(in) :: xyz_CDensNl(imin:imax,jmin:jmax,kmin:kmax)
    real(DP), intent(inout) :: xyz_DCDensDtNl(imin:imax,jmin:jmax,kmin:kmax)
    real(DP)             :: pyz_Orig(imin:imax,jmin:jmax,kmin:kmax)
    real(DP)             :: pyz_Adv(imin:imax,jmin:jmax,kmin:kmax)
    real(DP)             :: pyz_NDiff(imin:imax,jmin:jmax,kmin:kmax)
    real(DP)             :: xqz_Orig(imin:imax,jmin:jmax,kmin:kmax)
    real(DP)             :: xqz_Adv(imin:imax,jmin:jmax,kmin:kmax)
    real(DP)             :: xqz_NDiff(imin:imax,jmin:jmax,kmin:kmax)
    real(DP)             :: xyr_Orig(imin:imax,jmin:jmax,kmin:kmax)
    real(DP)             :: xyr_Adv(imin:imax,jmin:jmax,kmin:kmax)
    real(DP)             :: xyr_NDiff(imin:imax,jmin:jmax,kmin:kmax)
    real(DP)             :: xyr_BuoyT(imin:imax,jmin:jmax,kmin:kmax)
    real(DP)             :: xyr_BuoyM(imin:imax,jmin:jmax,kmin:kmax)
    real(DP)             :: xyr_BuoyD(imin:imax,jmin:jmax,kmin:kmax)
    real(DP)             :: xyz_Orig(imin:imax,jmin:jmax,kmin:kmax)
    real(DP)             :: xyz_Adv(imin:imax,jmin:jmax,kmin:kmax)
    real(DP)             :: xyz_NDiff(imin:imax,jmin:jmax,kmin:kmax)
    real(DP)             :: xyz_PTempAll(imin:imax,jmin:jmax,kmin:kmax)
    real(DP)             :: xyzf_Orig(imin:imax,jmin:jmax,kmin:kmax, 1:ncmax)
    real(DP)             :: xyzf_Adv(imin:imax,jmin:jmax,kmin:kmax, 1:ncmax)
    real(DP)             :: xyzf_NDiff(imin:imax,jmin:jmax,kmin:kmax, 1:ncmax)
    real(DP)             :: xyzf_QMixAll(imin:imax,jmin:jmax,kmin:kmax, 1:ncmax)
    real(DP)             :: xyzf_QMixPerMolWt(imin:imax,jmin:jmax,kmin:kmax, 1:GasNum)
    integer              :: f

    !------------------------------
    ! tendency of cloud density    
    ! 

    ! initialize 
    xyz_Orig = xyz_DCDensDtNl

    ! եåη׻. 4 濴ʬѤƷ׻
    !
    xyz_Adv = &
      & - xyz_c4dx_pyz(pyz_VelXNl * pyz_avr_xyz(xyz_CDensNl)) &
      & - xyz_c4dy_xqz(xqz_VelYNl * xqz_avr_xyz(xyz_CDensNl)) &
      & - xyz_c4dz_xyr(xyr_VelZNl * xyr_avr_xyz(xyz_CDensNl)) 

    ! Ǵη׻
    xyz_NDiff = &
      &  + NuHh * (xyz_dx_pyz(pyz_dx_xyz(xyz_CDensBl))) &
      &  + NuHh * (xyz_dy_xqz(xqz_dy_xyz(xyz_CDensBl))) &
      &  + NuVh * (xyz_dz_xyr(xyr_dz_xyz(xyz_CDensBl))) 
    
    xyz_DCDensDtNl = xyz_Orig + xyz_Adv + xyz_NDiff

    call HistoryAutoPut(Time, 'CDensAdv',  xyz_Adv(1:nx,1:ny,1:nz))
    call HistoryAutoPut(Time, 'CDensNDiff', xyz_NDiff(1:nx,1:ny,1:nz))

    !----------------------------------
    ! Ȼ
    !

    ! Initialize
    !
    xyz_Orig = xyz_DKmDtNl

    ! Advection term
    !
    xyz_Adv  =                                              &
      & - xyz_avr_pyz(pyz_VelXNl * pyz_c4dx_xyz(xyz_KmNl))  &
      & - xyz_avr_xqz(xqz_VelYNl * xqz_c4dy_xyz(xyz_KmNl))  &
      & - xyz_avr_xyr(xyr_VelZNl * xyr_c4dz_xyz(xyz_KmNl))    

    ! Numerical diffusion term 
    !
    xyz_NDiff =                                        &
      &    NuHm * (xyz_dx_pyz(pyz_dx_xyz( xyz_KmBl ))) &
      &  + NuHm * (xyz_dy_xqz(xqz_dy_xyz( xyz_KmBl ))) &
      &  + NuVm * (xyz_dz_xyr(xyr_dz_xyz( xyz_KmBl ))) 

    xyz_DKmDtNl = xyz_Orig + xyz_Adv + xyz_NDiff


    ! tendency of potential temperature
    ! 

    ! initialize 
    xyz_Orig = xyz_DPTempDtNl
    xyz_PTempAll = xyz_PTempNl + xyz_PTempBZ

    ! Advection term
    ! xyz_AdvScalar( xyz_PTempNl + xyz_PTempBZ, pyz_VelXNl, pyz_VelXNl, xyr_VelZNl) 
    !
    xyz_Adv = &
      & - xyz_avr_pyz(pyz_VelXNl * pyz_c4dx_xyz(xyz_PTempAll))  &
      & - xyz_avr_xqz(xqz_VelYNl * xqz_c4dy_xyz(xyz_PTempAll))  &
      & - xyz_avr_xyr(xyr_VelZNl * xyr_c4dz_xyz(xyz_PTempAll))  

    ! numerical diffusion term
    ! xyz_Num = xyz_NumDiffScalar( xyz_PTempBl)
    !
    xyz_NDiff = &
      &    NuHh * (xyz_dx_pyz(pyz_dx_xyz( xyz_PTempBl ))) &
      &  + NuHh * (xyz_dy_xqz(xqz_dy_xyz( xyz_PTempBl ))) &
      &  + NuVh * (xyz_dz_xyr(xyr_dz_xyz( xyz_PTempBl ))) 

    ! sum
    !
    xyz_DPTempDtNl = xyz_Orig + xyz_Adv + xyz_NDiff
    
    ! output
    !
    call HistoryAutoPut(Time, 'PTempAdv',   xyz_Adv(1:nx,1:ny,1:nz))
    call HistoryAutoPut(Time, 'PTempNDiff', xyz_NDiff(1:nx,1:ny,1:nz))

    xyz_PTempAl = xyz_PTempBl + DelTime * xyz_DPTempDtNl

    ! Set Margin
    !
    call SetMargin_xyz(xyz_PTempAl)

    
    !------------------------------
    ! tendency of mixing ratio
    ! 

    ! initialize
    xyzf_Orig = xyzf_DQMixDtNl
    xyzf_QMixAll = xyzf_QMixNl + xyzf_QMixBZ

    do f = 1, ncmax
      ! Advection term
      !xyzf_Adv  = xyzf_AdvScalar(xyzf_QMixNl + xyzf_QMixBZ, pyz_VelXNl, xqz_VelYNl, xyr_VelZNl)
      !
      xyzf_Adv(:,:,:,f) = &
        & - xyz_avr_pyz(pyz_VelXNl * pyz_c4dx_xyz(xyzf_QMixAll(:,:,:,f))) &
        & - xyz_avr_xqz(xqz_VelYNl * xqz_c4dy_xyz(xyzf_QMixAll(:,:,:,f))) &
        & - xyz_avr_xyr(xyr_VelZNl * xyr_c4dz_xyz(xyzf_QMixAll(:,:,:,f)))    

      ! numerical diffusion term
      ! xyzf_Diff = xyzf_NumDiffScalar(xyzf_QMixBl) 
      !
      xyzf_NDiff(:,:,:,f) = &
        &    NuHh * (xyz_dx_pyz(pyz_dx_xyz( xyzf_QMixBl(:,:,:,f) ))) &
        &  + NuHh * (xyz_dy_xqz(xqz_dy_xyz( xyzf_QMixBl(:,:,:,f) ))) &
        &  + NuVh * (xyz_dz_xyr(xyr_dz_xyz( xyzf_QMixBl(:,:,:,f) ))) 
    end do

    ! sum
    !
    xyzf_DQMixDtNl = xyzf_Orig + xyzf_Adv + xyzf_NDiff

    ! output
    !
    do f = 1, ncmax
      call HistoryAutoPut(Time, trim(SpcWetSymbol(f))//'_Adv',   xyzf_Adv(1:nx,1:ny,1:nz,f))
      call HistoryAutoPut(Time, trim(SpcWetSymbol(f))//'_NDiff', xyzf_NDiff(1:nx,1:ny,1:nz,f))
    end do

    ! time integration
    !
    xyzf_QMixAl = xyzf_QMixBl + DelTime * xyzf_DQMixDtNl

    ! Set Margin
    ! 
    call SetMargin_xyzf(xyzf_QMixAl)

    ! ͤ
    !
    call FillNegativeQMix(Time, DelTime, xyzf_QMixAl)

    ! Set Margin
    ! 
    call SetMargin_xyzf(xyzf_QMixAl)

    !------------------------------
    ! tendency of VelX
    ! 

    ! initializa
    !
    pyz_Orig = pyz_DVelXDtNl

    ! Advection term
    !pyz_Adv  = pyz_AdvVelX(pyz_VelXNl, xqz_VelYNl, xyr_VelZNl) 
    !
    pyz_Adv  = &
      & - pyz_VelXNl * pyz_avr_xyz( xyz_c4dx_pyz( pyz_VelXNl ) )                &
      & - pyz_avr_pqz( pqz_avr_xqz( xqz_VelYNl ) * pqz_c4dy_pyz( pyz_VelXNl ) ) &
      & - pyz_avr_pyr( pyr_avr_xyr( xyr_VelZNl ) * pyr_c4dz_pyz( pyz_VelXNl ) )

    ! Numerical diffusion term 
    !pyz_Diff = pyz_NumDiffVelX(pyz_VelXBl)
    pyz_NDiff = &
      &   NuHm * ( pyz_dx_xyz( xyz_dx_pyz( pyz_VelXBl ) ) ) &
      & + NuHm * ( pyz_dy_pqz( pqz_dy_pyz( pyz_VelXBl ) ) ) &
      & + NuVm * ( pyz_dz_pyr( pyr_dz_pyz( pyz_VelXBl ) ) )

    ! sum
    !
    pyz_DVelXDtNl = pyz_Orig + pyz_Adv + pyz_NDiff

    call HistoryAutoPut(Time, 'VelXAdv',   pyz_Adv(1:nx,1:ny,1:nz))
    call HistoryAutoPut(Time, 'VelXNDiff', pyz_NDiff(1:nx,1:ny,1:nz))

    !------------------------------
    ! tendency of VelY
    !     

    ! ininitalize
    xqz_Orig = xqz_DVelYDtNl

    ! Advection term
    ! xqz_Adv  = xqz_AdvVelY(pyz_VelXNl, xqz_VelYNl, xyr_VelZNl)
    !
    xqz_Adv  = &
      & - xqz_avr_pqz( pqz_avr_pyz( pyz_VelXNl ) * pqz_c4dx_xqz( xqz_VelYNl ) ) &
      & - xqz_VelYNl * xqz_avr_xyz( xyz_c4dy_xqz( xqz_VelYNl ) ) &
      & - xqz_avr_xqr( xqr_avr_xyr( xyr_VelZNl ) * xqr_c4dz_xqz( xqz_VelYNl ) )

    ! Numerical diffusion term
    ! xqz_Diff = xqz_NumDiffVelY(xqz_VelYBl)
    !
    xqz_NDiff = &
      &   NuHm * ( xqz_dx_pqz( pqz_dx_xqz( xqz_VelYBl ) ) ) &
      & + NuHm * ( xqz_dy_xyz( xyz_dy_xqz( xqz_VelYBl ) ) ) &
      & + NuVm * ( xqz_dz_xqr( xqr_dz_xqz( xqz_VelYBl ) ) )

    ! sum
    !
    xqz_DVelYDtNl = xqz_Orig + xqz_Adv + xqz_NDiff
    
    call HistoryAutoPut(Time, 'VelYAdv',   xqz_Adv(1:nx,1:ny,1:nz))
    call HistoryAutoPut(Time, 'VelYNDiff', xqz_NDiff(1:nx,1:ny,1:nz))

    !------------------------------
    ! tendency of VelZ
    ! 

    ! Initialization
    !
    xyr_Orig = xyr_DVelZDtNl
    
    do f = 1, GasNum
      xyzf_QMixPerMolWt(:,:,:,f) = xyzf_QMixNl(:,:,:,IdxG(f)) / MolWtWet(IdxG(f))
    end do

    ! Advection term
    ! xyr_Adv  = xyr_AdvVelZ(pyz_VelXNl, xqz_VelYNl, xyr_VelZNl)
    !
    xyr_Adv  = &
      & - xyr_avr_pyr( pyr_avr_pyz( pyz_VelXNl ) * pyr_c4dx_xyr( xyr_VelZNl ) ) &
      & - xyr_avr_xqr( xqr_avr_xqz( xqz_VelYNl ) * xqr_c4dy_xyr( xyr_VelZNl ) ) &
      & - xyr_VelZNl * xyr_avr_xyz( xyz_c4dz_xyr( xyr_VelZNl ) )

    ! Numerical diffusion term
    !xyr_Diff = xyr_NumDiffVelZ(xyr_VelZBl)
    !
    xyr_NDiff = &
      &   NuHm * ( xyr_dx_pyr( pyr_dx_xyr( xyr_VelZBl ) ) ) &
      & + NuHm * ( xyr_dy_xqr( xqr_dy_xyr( xyr_VelZBl ) ) ) & 
      & + NuVm * ( xyr_dz_xyz( xyz_dz_xyr( xyr_VelZBl ) ) )

    ! Buoyancy due to temperature disturbunce
    !xyr_BuoyT = xyr_Buoy(xyz_PTempNl)
    !
    xyr_BuoyT = Grav * xyr_avr_xyz( xyz_PTempNl / xyz_PTempBZ)

    ! Buoyancy due to molecular weight
    !
    ! ̤ǤʤɤΤ??
    xyr_BuoyM =                                                   &
      & + Grav * xyr_avr_xyz( sum(xyzf_QMixPerMolWt, 4) )        &
      &    / ( 1.0d0 / MolWtDry + xyr_QMixBZPerMolWt )       &
      & - Grav * xyr_avr_xyz( sum(xyzf_QMixNl(:,:,:,1:GasNum), 4) )&
      &    / ( 1.0d0 + xyr_QmixBZ )

    ! Buoyancy due to loading
    !
    xyr_BuoyD =                                                           &
      & - Grav * xyr_avr_xyz( sum(xyzf_QMixNl(:,:,:,GasNum+1:ncmax), 4) ) &
      &    / ( 1.0d0 + xyr_QMixBZ )

    ! sum
    !
    xyr_DVelZDtNl = xyr_Orig + xyr_Adv + xyr_NDiff + xyr_BuoyT + xyr_BuoyM + xyr_BuoyD

    call HistoryAutoPut(Time, 'VelZAdv',   xyr_Adv(1:nx,1:ny,1:nz))
    call HistoryAutoPut(Time, 'VelZNDiff', xyr_NDiff(1:nx,1:ny,1:nz))    
    call HistoryAutoPut(Time, 'VelZBuoyT', xyr_BuoyT(1:nx,1:ny,1:nz))    
    call HistoryAutoPut(Time, 'VelZBuoyM', xyr_BuoyM(1:nx,1:ny,1:nz))    
    call HistoryAutoPut(Time, 'VelZBuoyD', xyr_BuoyD(1:nx,1:ny,1:nz))    

  end subroutine Dynamics_Long_forcing
 

  subroutine Dynamics_Short_forcing(  &
        &  Time, DelTime,       & ! (in)
        &  pyz_VelXNs,          & ! (in)
        &  xqz_VelYNs,          & ! (in)
        &  xyr_VelZNs,          & ! (in)
        &  xyz_ExnerNs,         & ! (in)
        &  pyz_DVelXDtNl,       & ! (in)
        &  xqz_DVelYDtNl,       & ! (in)
        &  xyr_DVelZDtNl,       & ! (in)
        &  xyz_DExnerDtNs,      & ! (in)
        &  pyz_VelXAs,          & ! (out)
        &  xqz_VelYAs,          & ! (out)
        &  xyr_VelZAs,          & ! (out)
        &  xyz_ExnerAs          & ! (out)
        & )

    real(DP), intent(in)  :: Time, DelTime
    real(DP), intent(in)  :: pyz_VelXNs(imin:imax,jmin:jmax,kmin:kmax)
    real(DP), intent(in)  :: xqz_VelYNs(imin:imax,jmin:jmax,kmin:kmax)
    real(DP), intent(in)  :: xyr_VelZNs(imin:imax,jmin:jmax,kmin:kmax)
    real(DP), intent(in)  :: xyz_ExnerNs(imin:imax,jmin:jmax,kmin:kmax)
    real(DP), intent(in)  :: pyz_DVelXDtNl(imin:imax,jmin:jmax,kmin:kmax)
    real(DP), intent(in)  :: xqz_DVelYDtNl(imin:imax,jmin:jmax,kmin:kmax)
    real(DP), intent(in)  :: xyr_DVelZDtNl(imin:imax,jmin:jmax,kmin:kmax)
    real(DP), intent(in)  :: xyz_DExnerDtNs(imin:imax,jmin:jmax,kmin:kmax)
    real(DP), intent(out) :: pyz_VelXAs(imin:imax,jmin:jmax,kmin:kmax)
    real(DP), intent(out) :: xqz_VelYAs(imin:imax,jmin:jmax,kmin:kmax)
    real(DP), intent(out) :: xyr_VelZAs(imin:imax,jmin:jmax,kmin:kmax)
    real(DP), intent(out) :: xyz_ExnerAs(imin:imax,jmin:jmax,kmin:kmax)

    real(DP) :: pyz_DVelXDtNs(imin:imax,jmin:jmax,kmin:kmax)
    real(DP) :: xqz_DVelYDtNs(imin:imax,jmin:jmax,kmin:kmax)
    real(DP) :: xyr_DVelZDtNs(imin:imax,jmin:jmax,kmin:kmax)
    real(DP) :: xyz_DivVel(imin:imax,jmin:jmax,kmin:kmax)

    ! initialize: Divergence of velocity
    !
    xyz_DivVel = &
      &   xyz_dx_pyz( pyz_VelXNs ) &
      & + xyz_dy_xqz( xqz_VelYNs ) &
      & + xyz_dz_xyr( xyr_VelZNs )
    
    !--------------------------------------
    ! VelX
    !
    pyz_DVelXDtNs =  &
      &   - pyz_avr_xyz( CpDry * xyz_PTempBZ ) &
      &     * ( pyz_dx_xyz( xyz_ExnerNs ) - pyz_dx_xyz( Nu * xyz_DivVel ) )  
    
    ! Time integration
    !
    pyz_VelXAs    = pyz_VelXNs + DelTime * (pyz_DVelXDtNl + pyz_DVelXDtNs)

    call HistoryAutoPut(Time, 'VelXPGrad', pyz_DVelXDtNs(1:nx,1:ny,1:nz))

    ! Set Margin
    !
    call SetMargin_pyz( pyz_VelXAs ) ! (inout)

    !--------------------------------------
    ! VelY
    !    
    xqz_DVelYDtNs =  &
      &   - xqz_avr_xyz( CpDry * xyz_PTempBZ ) &
      &     * ( xqz_dy_xyz( xyz_ExnerNs ) - xqz_dy_xyz( Nu * xyz_DivVel ) )
    
    ! Time integration
    !
    xqz_VelYAs = xqz_VelYNs + DelTime * (xqz_DVelYDtNl + xqz_DVelYDtNs)

    call HistoryAutoPut(Time, 'VelYPGrad', xqz_DVelYDtNs(1:nx,1:ny,1:nz))

    ! Set Margin
    !
    call SetMargin_xqz( xqz_VelYAs ) ! (inout)
    
    !--------------------------------------
    ! Exner function
    !
    xyz_ExnerAs = xyz_Exner( &
      & pyz_VelXNs,          &
      & pyz_VelXAs,          &
      & xqz_VelYNs,          &
      & xqz_VelYAs,          &
      & xyr_VelZNs,          &
      & xyz_ExnerNs,         &
      & xyr_DVelZDtNl,       &
      & xyz_DExnerDtNs       &
      & )

    ! Set Margin
    !
    call SetMargin_xyz( xyz_ExnerAs ) ! (inout)

    !--------------------------------------
    ! VelZ
    !
    xyr_DVelZDtNs =                                         &
      & - xyr_avr_xyz(CpDry * xyz_PTempBZ )                   &
      &   * (                                               &
      &       beta * xyr_dz_xyz( xyz_ExnerAs )              &
      &       + (1.0d0 - beta) * xyr_dz_xyz( xyz_ExnerNs )  &
      &       - xyr_dz_xyz( Nu * xyz_DivVel )               &
      &     )                                                  
    
    ! Time integration
    !
    xyr_VelZAs = xyr_VelZNs + DelTime * (xyr_DVelZDtNl + xyr_DVelZDtNs)

    call HistoryAutoPut(Time, 'VelZPGrad', xyr_DVelZDtNs(1:nx,1:ny,1:nz))

    ! Set Margin
    !
    call SetMargin_xyr( xyr_VelZAs ) ! (inout)

  end subroutine Dynamics_Short_forcing

  
!!!--------------------------------------------------------------------!!!
  subroutine DynamicsVI_init()
    !
    !ʡؿ򱢲ˡǲ򤯺ݤɬפȤʤ, Ǥ, 
    !LU ʬԤ. 
    !

    !ۤηػ
    implicit none

    real(DP)  :: DTS ! ûֳʻ

    DTS = DelTimeShort

    RegXMin = 1
    RegXMax = nx
    RegYMin = 1
    RegYMax = ny
    RegZMin = 1
    RegZMax = nz

    !γդ
    allocate( A(RegZMin:RegZMax) )
    allocate( B(RegZMin+1:RegZMax) )
    allocate( C(RegZMin:RegZMax-1) )
    allocate( xyz_F1BZ(imin:imax,jmin:jmax,kmin:kmax) )
    allocate( xyr_F2BZ(imin:imax,jmin:jmax,kmin:kmax) )

    !----------------------------------------------------------------
    ! ȶ̤Ѥͤ
    !----------------------------------------------------------------

    !η׻
    !  A, B, C , F1BZ  F2BZ  X ˰ͤʤΤ. 
    !  RegXMax, RegYMax ͤɽ뤳ȤȤ. 
    xyz_F1BZ =                                                &
      &  ( xyz_VelSoundBZ ** 2.0d0 )                          &
      &   / (CpDry * xyz_DensBZ * (xyz_VPTempBZ ** 2.0d0))

    xyr_F2BZ =                                                 &
      &  xyr_avr_xyz(                                               &
      &    CpDry * xyz_DensBZ * ( xyz_VPTempBZ ** 2.0d0 ) &
      &   )
    
    A(RegZMin+1: RegZMax-1) =                                &
      & (beta ** 2.0d0)                                    &
      &    * xyz_F1BZ(RegXMax,RegYMax,RegZMin+1: RegZMax-1)      &  
      &    * (                                               &
      &          xyr_F2BZ(RegXMax,RegYMax,RegZMin+1: RegZMax-1)  &
      &            / r_dz(RegZMin+1: RegZMax-1)              &
      &        + xyr_F2BZ(RegXMax,RegYMax,RegZMin  : RegZMax-2)  &
      &            / r_dz(RegZMin: RegZMax-2)                &
      &       )                                              &
      &    * (DTS ** 2.0d0)                                  &
      &    / z_dz(RegZMin+1: RegZMax-1)                      &
      & + 1.0d0

    A(RegZMin) =                                        &
      & (beta ** 2.0d0)                               &
      &   * xyz_F1BZ(RegXMax,RegYMax,RegZMin)       &
      &   * xyr_F2BZ(RegXMax,RegYMax,RegZMin)       &
      &     / r_dz(RegZMin)                             &
      &   * (DTS ** 2.0d0)                              &
      &   / z_dz(RegZMin)                               &
      & + 1.0d0                                         

    A(RegZMax) =                                        &
      & (beta ** 2.0d0)                               &
      &   * xyz_F1BZ(RegXMax,RegYMax,RegZMax)       &
      &   * xyr_F2BZ(RegXMax,RegYMax,RegZMax-1)     &
      &     / r_dz(RegZMax-1)                           &
      &   * (DTS ** 2.0d0)                              &
      &   / z_dz(RegZMax)                               &
      & + 1.0d0                                         
    
    B(RegZMin+1:RegZMax) =                             &
      & - (beta ** 2.0d0)                               &
      &   * xyz_F1BZ(RegXMax,RegYMax,RegZMin:RegZMax-1)    &
      &   * xyr_F2BZ(RegXMax,RegYMax,RegZMin:RegZMax-1)    &
      &     / r_dz(RegZmin:RegZMax-1)                   &
      &   * (DTS ** 2.0d0)                     &
      &   / z_dz(RegZMin:RegZMax-1)
    
    C(RegZMin: RegZMax-1) =                           &
      & - ( beta ** 2.0d0 )                           &
      &   * xyz_F1BZ(RegXMax,RegYMax,RegZMin+1:RegZMax)    &
      &   * xyr_F2BZ(RegXMax,RegYMax,RegZMin  :RegZMax-1)  &
      &     / r_dz(RegZmin:RegZMax-1)                   &
      &   * (DTS ** 2.0d0) &
      &   / z_dz(RegZMin+1:RegZMax)


    !ǥХåϥե륪ץ. . 
!    call FileOpen(unit, file="dynimpfunc_log", mode='w')
!    write(unit,*) "kz, A_k"
!    write(unit,*) "------------------------------------"
!    do kz = RegZmin, RegZmax
!      write(unit,*) kz, A(kz)
!    end do
!    write(unit,*) "------------------------------------"
!    write(unit,*) "kz, B_k"
!    write(unit,*) "------------------------------------"
!    do kz = RegZmin+1, RegZmax
!      write(unit,*) kz, B(kz)
!    end do
!    write(unit,*) "------------------------------------"
!    write(unit,*) "kz, C_k"
!    write(unit,*) "------------------------------------"
!    do kz = RegZmin, RegZmax-1
!      write(unit,*) kz, C(kz)
!    end do
!    write(unit,*) "------------------------------------"
!    close(unit)


    !----------------------------------------------------------------
    !  LU ʬ
    !----------------------------------------------------------------
    !礭ݴ
    N   = RegZMax - RegZMin +1 !/μ, ˡ
    M   = (RegXMax - RegXMin +1)*(RegYMax - RegYMin +1) 
                               !ȿ
    NUD = 1                    !ξ廰ʬ
    NLD = 1                    !βʬ
    NAL = NLD                  !LU ʬη L ˡ
    NA  = NUD + NLD + 1

    !γ
!    allocate( AL1(N), AL2(NAL, N), AU2(NA, N), IP(N) )
    allocate( AL1(N), IP(N) )

    !LU ʬμ¹
    !  LAPACK 
    call ResolvLU_Lapack( )

   
  end subroutine DynamicsVI_init
  

!!!--------------------------------------------------------------------!!!
  function xyz_Exner(      &
    & pyz_VelXNs,          &
    & pyz_VelXAs,          &
    & xqz_VelYNs,          &
    & xqz_VelYAs,          &
    & xyr_VelZNs,          &
    & xyz_ExnerNs,         &
    & xyr_DVelZDtNl,       &
    & xyz_DExnerDtNs       &
    & )
    !
    !ˡѤʡؿη׻. 
    !

    !ۤηػ
    implicit none
    
    !ѿ
    real(DP), intent(in)   :: pyz_VelXNs &
      &                     (imin:imax,jmin:jmax,kmin:kmax) 
                                                           !® u []
    real(DP), intent(in)   :: pyz_VelXAs &
      &                     (imin:imax,jmin:jmax,kmin:kmax) 
                                                           !® u [+]
    real(DP), intent(in)   :: xqz_VelYNs &
      &                     (imin:imax,jmin:jmax,kmin:kmax) 
                                                           !® v []
    real(DP), intent(in)   :: xqz_VelYAs &
      &                     (imin:imax,jmin:jmax,kmin:kmax) 
                                                           !® v [+]
    real(DP), intent(in)   :: xyr_VelZNs &
      &                     (imin:imax,jmin:jmax,kmin:kmax) 
                                                           !® w []
    real(DP), intent(in)   :: xyr_DVelZDtNl &
      &                     (imin:imax,jmin:jmax,kmin:kmax) 
                                                           !Z γϹ[t]
    real(DP), intent(in)   :: xyz_DExnerDtNs &
      &                     (imin:imax,jmin:jmax,kmin:kmax) 
                                                           !Z γϹ[t]
    real(DP), intent(in)   :: xyz_ExnerNs &
      &                     (imin:imax,jmin:jmax,kmin:kmax) 
                                                           !̵
    real(DP)               :: xyz_Exner &
      &                     (imin:imax,jmin:jmax,kmin:kmax) 
                                                           !̵[+]

    !ѿ
    real(DP)  :: D1(imin:imax,jmin:jmax,kmin:kmax)  
    real(DP)  :: D2(RegXMin:RegXMax,RegYMin:RegYMax,RegZMin:RegZMax)  
    real(DP)  :: D((RegXMax-RegXMin+1)*(RegYMax-RegYMin+1),(RegZMax-RegZMin+1))
    real(DP)  :: E(imin:imax,jmin:jmax,kmin:kmax)  
    real(DP)  :: F(imin:imax,jmin:jmax,kmin:kmax)  
    real(DP)  :: xyz_DivVelNs(imin:imax,jmin:jmax,kmin:kmax)
    real(DP)  :: DTS ! ûֳʻҴֳ
    integer   :: ix, jy, kz

    DTS = DelTimeShort

    !ѿν
    xyz_Exner = 0.0d0
    
    !®٤μ«׻
    xyz_DivVelNs =  xyz_dx_pyz( pyz_VelXNs )   &
      &             + xyz_dy_xqz( xqz_VelYNs ) &
      &             + xyz_dz_xyr( xyr_VelZNs )
  
    !׻Τη
    E = xyr_dz_xyz( Nu * xyz_DivVelNs )                       &
      & - ( 1.0d0 - beta ) * xyr_dz_xyz( xyz_ExnerNs )        &
      & + xyr_DVelZDtNl / xyr_avr_xyz( CpDry * xyz_VPTempBZ ) 
    
    F = - beta * xyz_F1BZ * DTS                                     &
      & * xyz_dz_xyr(                                               &
      &    xyr_avr_xyz( xyz_DensBZ * xyz_VPTempBZ)                  &
      &    * (                                                      &
      &         xyr_VelZNs                                          &
      &       - xyr_avr_xyz(CpDry * xyz_VPTempBZ) * DTS             &
      &         * (                                                 &
      &               (1.0d0 - beta) * xyr_dz_xyz( xyz_ExnerNs )    &
      &             - xyr_dz_xyz( Nu * xyz_DivVelNs )               &
      &            )                                                &
      &       + xyr_DVelZDtNl * DTS                                 &
      &      )                                                      &
      &   )                                                         &
      & + xyz_DExnerDtNs * DTS

    D1 = xyz_ExnerNs                                                &
      & - (1.0d0 - beta)                                            &
      &   * xyz_F1BZ * DTS                                          &
      &   * xyz_dz_xyr(                                             &
      &       xyr_avr_xyz(xyz_DensBZ * xyz_VPTempBZ) * xyr_VelZNs   &
      &     )                                                       &
      & - (xyz_VelSoundBZ ** 2.0d0) * DTS                           &
      &   / (CpDry * xyz_VPTempBZ) * xyz_dx_pyz( pyz_VelXAs )       &
      & - (xyz_VelSoundBZ ** 2.0d0) * DTS                           & 
      &   / (CpDry * xyz_VPTempBZ) * xyz_dy_xqz( xqz_VelYAs )       &
      & + F

    D1(:,:,RegZMin) = D1(:,:,RegZMin)                           &
      & - beta * xyz_F1BZ(:,:,RegZMin) * (DTS ** 2.0d0)         &
      &   * xyr_F2BZ(:,:, RegZMin-1) * E(:,:,RegZMin-1)         &
      &   / z_dz(RegZMin)
    
    D1(:,:,RegZMax) = D1(:,:,RegZMax)                           &
      & + beta * xyz_F1BZ(:,:,RegZMax) * (DTS ** 2.0d0)         &
      &   * xyr_F2BZ(:,:,RegZMax) * E(:,:,RegZMax)              &
      &   / z_dz(RegZMax)     

    D2 = D1(RegXMin:RegXMax,RegYMin:RegYMax,RegZMin:RegZMax)

    do kz = RegZMin, RegZMax
      do jy = RegYMin, RegYMax 	
        do ix = RegXMin, RegXMax 	
	  D(ix + (RegXMax-RegXMin+1) * (jy - 1), kz) =  D2(ix,jy,kz)
        end do 
      end do
    end do	
   
    !-----------------------------------------------------------
    !ϢΩ켡β
    !------------------------------------------------------------

    !η׻
    !  LAPACK 
    call LinSolv_Lapack( D )

    !ͤ
    do kz = RegZMin, RegZMax
      do jy = RegYMin, RegYMax 	
        do ix = RegXMin, RegXMax 	
          xyz_Exner(ix,jy,kz) = D(ix + (RegXMax-RegXMin+1) * (jy - 1 ), kz)
        end do 
      end do
    end do	
   
  end function xyz_Exner

!!!--------------------------------------------------------------------!!!
  subroutine ResolvLU_Lapack(  )
    !
    ! 3  LU ʬ(). LAPACK 
    !

    !ۤηػ
    implicit none

    !ѿ
    integer    :: INFO  !Υǥå
    
    !ѿν
    INFO = 0
    
    !η׻. LAPACK . 
    call DGTTRF(N, C, A, B, AL1, IP, INFO)
    
    !Υǥå. 
    if (INFO /= 0) then
      call MessageNotify("Error", "lapack_linear", "INFO is not 0")
      stop
    end if
    
  end subroutine ResolvLU_Lapack
  

!!!--------------------------------------------------------------------!!!
  subroutine LinSolv_Lapack( X )
    !
    !LU ʬ򤵤줿 3 ϢΩ 1 (). LAPACK 
    !

    !ۤηػ
    implicit none
    
    !ѿ
    real(DP), intent(inout) :: X(M, N)     !/
    real(DP)                :: TX(N, M)    !ž֤
    integer                :: NRHS         !
    integer                :: INFO
    integer                :: LDB
    character(1),parameter :: TRANS = 'N'

    !ѿν
    NRHS = M
    INFO = 0
    LDB  = N
    TX = transpose( X )
    
    !η׻. LAPACK . 
    call DGTTRS(TRANS, N, NRHS, C, A, B, AL1, IP, TX, LDB, INFO)

    !ν
    X = transpose( TX )
     
    !Υǥå. 
    if (INFO /= 0) then
      call MessageNotify("Error", "lapack_linear", "INFO is not 0")
      stop
    end if
     
  end subroutine LinSolv_Lapack

end module DynamicsHEVI

